'gbRuler by Gary Beene, 2011 + help from forum members!
#Compile Exe
#Dim All
#Debug Error On
#Debug Display On
#Include "Win32API.inc"
#Resource "gbruler.pbr"

Type CustomColors
   c(15) As Long
End Type

Type gbPoint
    x  As Long
    y As Long
    col As Long
End Type

$Ver = "3.05   (18 Feb 2011)

%WM_SysTray    = %WM_User +  1

%Pixel          = 1
%Pica           = 6
%Twip           = 1440
%Inch10         = 10
%Inch123        = 123
%Inch124        = 124
%Inch16         = 16
%DialogUnit     = 125
%Centimener     = 254

%Cursor_Default = 1
%Cursor_Cross = 2
%Cursor_NESW  = 8
%Cursor_Diagonal = 8

%Display_None = 0
%Display_RulerSize = 1
%Display_CursorLoc = 2

%IDM_Vertical   = 501
%IDM_Horizontal = 502
%IDM_LeftToRight= 503
%IDM_Exit       = 504
%IDM_Sep        = 505
%IDM_OnTop      = 506
%IDM_Pixels     = 507
%IDM_Inches16   = 508
%IDM_FG         = 509
%IDM_BG         = 510
%IDM_Default    = 511
%IDM_Minimize   = 512
%IDM_Dim        = 513
%IDM_Inches10   = 514
%IDM_Centimeters= 515
%IDM_About      = 516
%IDM_SetFont    = 517
%IDM_DefaultFont= 518
%IDM_UseOffset  = 519
%IDM_SingleSide = 520
%IDM_Inches123  = 521
%IDM_Inches124  = 522
%IDM_Twips      = 523
%IDM_Pica       = 524
%IDM_Display    = 525
%IDM_DisplayNone= 526
%IDM_DisplaySize= 527
%IDM_DisplayCursor= 528
%IDM_AdjustPPI  = 529
%IDM_AdjustPPIX = 530
%IDM_AdjustPPIY = 531
%IDM_LastFont   = 532
%IDM_SysTrayQuit= 533
%IDM_SysTrayMin = 534
%IDM_StartupMin = 535
%IDM_SysTrayRestore = 536
%IDM_DialogUnit = 537

%IDM_Right      = 550
%IDM_Left       = 551
%IDM_Up         = 552
%IDM_Down       = 553
%IDM_sRight     = 554
%IDM_sLeft      = 555
%IDM_sUp        = 556
%IDM_sDown      = 557

Global hDlg, hDC, hBMP, hBMPDC, hContext, hScales, hDisplay As Dword
Global hAdjustPPI, hColors, hTrayMenu As Dword
Global resizePT, pt As PointAPI, CustomColorList As CustomColors
Global startX, startY, LayoutHorizontal, LeftToRight, ResizeInWork, TransparentInWork As Long
Global OnTop, ScaleUnits, cFore, cBack, cBG, DimOnLostFocus, Transparency As Long
Global FontName As String, FontSize, FontAttr As Long, hFont As Dword
Global UseOffset, SingleSide, GripperSize, DisplayType As Long
Global AdjustPPI, CustomPPIX, CustomPPIY As Long
Global LastFontName As String, LastFontSize, LastFontAttr As Long
Global tn As NotifyIconData, SysTrayMin, StartupMin As Long
Global RulerLength, StartOffSet, LastFractionnalSpace As Long, sRulerLength As String

Function PBMain() As Long
   Dialog New Pixels, 0, "Ruler",300,300,400,50, %WS_Popup + %WS_Border, %WS_Ex_Layered To hDlg
   Dialog Set Icon hDlg, "ruler"
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y,w,h As Long, PS As PaintStruct, tempZ As Asciiz*6, Length As Single
   Local PointPerInchX, PointPerInchY As Long
   Static MouseInRuler As Long

   Select Case Cb.Msg

      Case %WM_InitDialog
         BuildAcceleratorTable
         Settings_INI "get"
         Font New FontName, FontSize, FontAttr To hFont
         cBG = cBack
         CreatehBMP
         CreateContextMenu
         AdjustFeatures
         If OnTop Then SetWindowPos hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE
         Menu Set State hContext, ByCmd %IDM_OnTop, OnTop * 8
         Menu Set State hContext, ByCmd %IDM_Dim, DimOnLostFocus * 8
         Menu Set State hContext, ByCmd %IDM_UseOffset, UseOffset * 8
         Menu Set State hContext, ByCmd %IDM_SingleSide, SingleSide * 8
         Menu Set State hContext, ByCmd %IDM_LeftToRight, LeftToRight * 8
         Menu Set State hContext, ByCmd %IDM_SysTrayMin, SysTrayMin * 8
         Menu Set State hContext, ByCmd %IDM_StartupMin, StartupMin * 8
         Menu Set State hContext, ByCmd %IDM_AdjustPPI, AdjustPPI * 8
         Menu Set Text  hContext, ByCmd %IDM_AdjustPPIX, "Set PPI &X   (" + Trim$(Str$(CustomPPIX)) + ")"
         Menu Set Text  hContext, ByCmd %IDM_AdjustPPIY, "Set PPI &Y   (" + Trim$(Str$(CustomPPIY)) + ")"
         SetLayeredWindowAttributes(hDlg, 0, Transparency, %LWA_ALPHA)
         If StartupMin Then MinimizeDialog

      Case %WM_MouseWheel
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
           Case > 0 : Transparency = Transparency + 10 : Transparency = Min(255,Transparency) ': If Transparency = 255 Then Beep
           Case < 0 : Transparency = Transparency - 10 : Transparency = Max(30,Transparency)  ': If Transparency = 30 Then Beep
         End Select
         SetWindowLong hDlg, %GWL_EXSTYLE, GetWindowLong(hDlg, %GWL_EXSTYLE) Or %WS_Ex_Layered
         SetLayeredWindowAttributes hDlg, 0, Transparency, %LWA_ALPHA

      Case %WM_LButtonDblClk
         If LayoutHorizontal Then
            Dialog Set Size hDlg,440,45
         Else
            Dialog Set Size hDlg,45, 440
         End If
         Transparency = 255
         SetWindowLong hDlg, %GWL_EXSTYLE, GetWindowLong(hDlg, %GWL_EXSTYLE) Or %WS_Ex_Layered
         SetLayeredWindowAttributes hDlg, 0, Transparency, %LWA_ALPHA

      Case %WM_Size
         DrawRuler
         Dialog ReDraw hDlg

      Case %WM_KillFocus
         If DimOnLostFocus Then
            cBG = cBack
            cBack = %rgb_Gainsboro
            CreatehBMP : DrawRuler : Dialog ReDraw hDlg
         End If

      Case %WM_SetFocus
         If DimOnLostFocus Then
            cBack = cBG
            CreatehBMP : DrawRuler : Dialog ReDraw hDlg
         End If

      Case %WM_ContextMenu
         Desktop Get Size To w,h
         x = Lo(Word,Cb.LParam) : y = Hi(Word, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         If y > (h-340) Then y = y - 340
         TrackPopupMenu hContext, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel       : Dialog End hDlg
            Case %IDM_SysTrayQuit: Dialog End hDlg
            Case %IDM_SysTrayRestore : Dialog Show State hDlg, %SW_Restore
            Case %IDM_Vertical   : LayoutHorizontal = 0 : AdjustFeatures
            Case %IDM_Horizontal : LayoutHorizontal = 1 : AdjustFeatures
            Case %IDM_Exit       : Dialog End hDlg
            Case %IDM_Left       : MoveDialog("L")
            Case %IDM_Right      : MoveDialog("R")
            Case %IDM_Up         : MoveDialog("U")
            Case %IDM_Down       : MoveDialog("D")
            Case %IDM_sLeft      : ResizeDialog(-5,0)
            Case %IDM_sRight     : ResizeDialog(+5,0)
            Case %IDM_sUp        : ResizeDialog(0,-5)
            Case %IDM_sDown      : ResizeDialog(0,+5)
            Case %IDM_Minimize   : MinimizeDialog

            Case %IDM_DisplayNone   : DisplayType = %Display_None      : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_DisplaySize   : DisplayType = %Display_RulerSize : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_DisplayCursor : DisplayType = %Display_CursorLoc : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg

            Case %IDM_AdjustPPIX
                CustomPPIX = GetPPI(CustomPPIX)
                Menu Set Text  hContext, ByCmd %IDM_AdjustPPIX, "Set PPI &X   (" + Trim$(Str$(CustomPPIX)) + ")"
            Case %IDM_AdjustPPIY
                CustomPPIY = GetPPI(CustomPPIY)
                Menu Set Text  hContext, ByCmd %IDM_AdjustPPIY, "Set PPI &Y   (" + Trim$(Str$(CustomPPIY)) + ")"
            Case %IDM_AdjustPPI
                AdjustPPI = AdjustPPI Xor 1
                DrawRuler : Dialog ReDraw hDlg
                Menu Set State hContext, ByCmd %IDM_AdjustPPI, AdjustPPI * 8

            Case %IDM_Pixels     : ScaleUnits = %Pixel      : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Pica       : ScaleUnits = %Pica       : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Twips      : ScaleUnits = %Twip       : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Inches10   : ScaleUnits = %Inch10     : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Inches123  : ScaleUnits = %Inch123    : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Inches124  : ScaleUnits = %Inch124    : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Inches16   : ScaleUnits = %Inch16     : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_DialogUnit : ScaleUnits = %DialogUnit : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_Centimeters: ScaleUnits = %Centimener : AdjustFeatures : DrawRuler : Dialog ReDraw hDlg

            Case %IDM_SetFont
                SelectFont : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_UseOffset
               UseOffset = UseOffset Xor 1
               Menu Set State hContext, ByCmd %IDM_UseOffset, UseOffset * 8
               DrawRuler : Dialog ReDraw hDlg
            Case %IDM_SingleSide
               SingleSide = SingleSide Xor 1
               Menu Set State hContext, ByCmd %IDM_SingleSide, SingleSide * 8
               DrawRuler : Dialog ReDraw hDlg
            Case %IDM_DefaultFont
               FontName = "MS Sans Serif" : FontSize = 10 : FontAttr = 0
               Font New FontName, FontSize, FontAttr To hFont
               DrawRuler : Dialog ReDraw hDlg
            Case %IDM_LastFont
               FontName = LastFontName : FontSize = LastFontSize  : FontAttr = LastFontAttr
               Font New FontName, FontSize, FontAttr To hFont
               DrawRuler : Dialog ReDraw hDlg
            Case %IDM_LeftToRight
               LeftToRight = LeftToRight Xor 1
               Menu Set State hContext, ByCmd %IDM_LeftToRight, LeftToRight * 8
               DrawRuler : Dialog ReDraw hDlg
            Case %IDM_SysTrayMin
               SysTrayMin = SysTrayMin Xor 1
               Menu Set State hContext, ByCmd %IDM_SysTrayMin, SysTrayMin * 8
            Case %IDM_StartupMin
               StartupMin = StartupMin Xor 1
               Menu Set State hContext, ByCmd %IDM_StartupMin, StartupMin * 8
            Case %IDM_Default
               cFore = %Black : cBack = %Yellow
               CreatehBMP : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_FG
               cFore = SelectColor(cFore)
               CreatehBMP : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_BG
               cBack = SelectColor(cBack) : cBG = cBack
               CreatehBMP : DrawRuler : Dialog ReDraw hDlg
            Case %IDM_OnTop
               OnTop = OnTop Xor 1
               Menu Set State hContext, ByCmd %IDM_OnTop, OnTop * 8
               SetWindowPos hDlg, IIf(OnTop, %HWND_TOPMOST, %HWND_NOTOPMOST), 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE
            Case %IDM_Dim
               DimOnLostFocus = DimOnLostFocus Xor 1
               Menu Set State hContext, ByCmd %IDM_Dim, DimOnLostFocus * 8
            Case %IDM_About
               DisplayAbout
         End Select

      Case %WM_RButtonDown
          TransparentInWork = 1

      Case %WM_LButtonDown
         Dialog Get Size hDlg To w,h
         GetCursorPos pt            'screen position
         ScreenToClient hDlg, pt    'overlay position
         If pt.x < (w-GripperSize) Or pt.y < (h-GripperSize) Then
            'off marker
            If Cb.WParam = %MK_LBUTTON Then SendMessage hDlg, %WM_NCLButtonDown, %HTCaption, ByVal %Null  ' force drag
         Else
            'on marker
            SetCapture hDlg
            resizePT = pt
            Dialog Get Size hDlg To startX,startY
            ResizeInWork = 1   'on marker
            MousePtr %Cursor_NESW
         End If

      Case %WM_Paint
         Dialog Get Size hDlg To w,h
         hDC = BeginPaint(hDlg, PS)
         BitBlt hDC, 0,0,w,h, hBMPDC, 0,0, %SRCCopy 'copy ruler image to dialog surface
         DisplayInfo
         EndPaint hDlg, PS

      Case %WM_MouseMove
          If (DisplayType = %Display_CursorLoc) And (MouseInRuler = %False) Then MouseInRuler = %True : MousePtr %Cursor_Cross

          GetCursorPos pt            'screen position
          ScreenToClient hDlg, pt    'overlay position

          If DisplayType = %Display_CursorLoc Then
              hDC = GetDC(hDlg)
              Graphic Get PPI To PointPerInchX, PointPerInchY
              If AdjustPPI Then PointPerInchX = CustomPPIX : PointPerInchY = CustomPPIY
              Length = IIf(LayoutHorizontal, pt.x-StartOffset, pt.y-StartOffset)
              Length = Max(Length,0)
              Select Case ScaleUnits
                 Case %Pixel           : tempZ = Format$(Length,"0000")
                 Case %Inch10,%Inch16,%Inch123,%Inch124
                                       : Length = Length / IIf(LayoutHorizontal, PointPerInchY, PointPerInchX)      : tempZ = Format$(Length,"000.0")
                 Case %Centimener      : Length = Length / IIf(LayoutHorizontal, PointPerInchY, PointPerInchX)*2.54 : tempZ = Format$(Length,"000.0")
                 Case %Twip            : Length = Length / IIf(LayoutHorizontal, PointPerInchY, PointPerInchX)*1440 : tempZ = Format$(Length,"00000")
                 Case %Pica            : Length = Length / IIf(LayoutHorizontal, PointPerInchY, PointPerInchX)*6    : tempZ = Format$(Length,"000.0")
                 Case %DialogUnit      : 'To do
              End Select
              TextOut hDC, 10,10, tempZ, Len(tempZ)
              ReleaseDC hDC, hDlg
          End If

          If ResizeInWork Then
               Dialog Set Size hDlg, Max(startX + (pt.x - resizePT.x), 20), Max(startY + (pt.y - resizePT.y), 20)
               MousePtr %Cursor_NESW : Function = 1
          Else
               Dialog Get Size hDlg To w,h
               If (pt.x > (w-GripperSize)) And (pt.y > (h-GripperSize)) Then MousePtr %Cursor_NESW : Function = 1 Else If DisplayType = %Display_CursorLoc Then MousePtr %Cursor_Cross
          End If

      Case %WM_MouseLeave
          MouseInRuler = %False

      Case %WM_LButtonUp
         MousePtr 1
         ResizeInWork = 0
         TransparentInWork = 0
         ReleaseCapture
         Dialog ReDraw hDlg

      Case %WM_SysTray
         Select Case Cb.LParam
            Case %WM_RButtonDown
               GetCursorPos pt
               TrackPopupMenu hTrayMenu, %TPM_BottomAlign Or %TPM_RightAlign, pt.x, pt.y, 0, hDlg, ByVal %null
               PostMessage hDlg, %WM_Null, 0, 0
            Case %WM_LButtonDblClk
               Dialog Show State hDlg, %SW_Restore
         End Select

      Case %WM_Destroy
         Shell_NotifyIcon %nim_delete, tn
         Settings_INI "save"
   End Select
End Function

Sub AdjustFeatures
   Local w,h As Long
   Dialog Get Size hDlg To w,h
   If LayoutHorizontal Then
      'horizontal
      Menu Set State hContext, ByCmd %IDM_Horizontal, 8
      Menu Set State hContext, ByCmd %IDM_Vertical, 0
      If (Max(w,h)) > 10 And (Min(w,h)>10) Then Dialog Set Size hDlg, Max(w,h), Min(w,h)
   Else
      'vertical
      Menu Set State hContext, ByCmd %IDM_Horizontal, 0
      Menu Set State hContext, ByCmd %IDM_Vertical, 8
      If (Min(w,h)>10) And (Max(w,h)>10) Then Dialog Set Size hDlg, Min(w,h), Max(w,h)
   End If

   'display text options
   Menu Set State hDisplay, ByCmd %IDM_DisplayNone,   0
   Menu Set State hDisplay, ByCmd %IDM_DisplaySize,   0
   Menu Set State hDisplay, ByCmd %IDM_DisplayCursor, 0
   Select Case DisplayType
       Case %Display_None      : Menu Set State hDisplay, ByCmd %IDM_DisplayNone,   8
       Case %Display_RulerSize : Menu Set State hDisplay, ByCmd %IDM_DisplaySize,   8
       Case %Display_CursorLoc : Menu Set State hDisplay, ByCmd %IDM_DisplayCursor, 8
   End Select

   'scale options
   Menu Set State hContext, ByCmd %IDM_Pixels,     0
   Menu Set State hContext, ByCmd %IDM_Centimeters,0
   Menu Set State hContext, ByCmd %IDM_Inches10,   0
   Menu Set State hScales, ByCmd %IDM_Inches16,    0
   Menu Set State hScales, ByCmd %IDM_Inches123,   0
   Menu Set State hScales, ByCmd %IDM_Inches124,   0
   Menu Set State hScales, ByCmd %IDM_Twips,       0
   Menu Set State hScales, ByCmd %IDM_Pica,        0
   Menu Set State hScales, ByCmd %IDM_DialogUnit,  0
   Select Case ScaleUnits
       Case %Pixel      : Menu Set State hContext, ByCmd %IDM_Pixels,      8
       Case %Pica       : Menu Set State hScales, ByCmd %IDM_Pica,         8
       Case %Twip       : Menu Set State hScales, ByCmd %IDM_Twips,        8
       Case %Inch10     : Menu Set State hContext, ByCmd %IDM_Inches10,    8
       Case %Inch123    : Menu Set State hScales, ByCmd %IDM_Inches123,    8
       Case %Inch124    : Menu Set State hScales, ByCmd %IDM_Inches124,    8
       Case %Inch16     : Menu Set State hScales, ByCmd %IDM_Inches16,     8
       Case %DialogUnit : Menu Set State hScales, ByCmd %IDM_DialogUnit,   8
       Case %Centimener : Menu Set State hContext, ByCmd %IDM_Centimeters, 8
   End Select
End Sub

Sub Settings_INI(Task$)
   Local xResult, yResult, tempAsciiZ As Asciiz * %Max_Path
   Local i,x,y As Long, INIFileName As Asciiz * %Max_Path
   INIFileName = EXE.Path$ + "gbruler.ini"   'defines file name (any file name will work)

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "440", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "45", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get string variables
      Getprivateprofilestring "All", "FontName", "MS Sans Serif", tempAsciiZ, %Max_Path, INIFileName
      FontName = tempAsciiZ

      Getprivateprofilestring "All", "LastFontName", "Consolas", tempAsciiZ, %Max_Path, INIFileName
      LastFontName = tempAsciiZ

      'get numeric variables
      Getprivateprofilestring "All", "LayoutHorizontal", "1", tempAsciiZ, %Max_Path, INIFileName
      LayoutHorizontal = Val(tempAsciiZ)

      Getprivateprofilestring "All", "LeftToRight", "1", tempAsciiZ, %Max_Path, INIFileName
      LeftToRight = Val(tempAsciiZ)

      Getprivateprofilestring "All", "SysTrayMin", "0", tempAsciiZ, %Max_Path, INIFileName
      SysTrayMin = Val(tempAsciiZ)

      Getprivateprofilestring "All", "StartupMin", "0", tempAsciiZ, %Max_Path, INIFileName
      StartupMin = Val(tempAsciiZ)

      Getprivateprofilestring "All", "OnTop", "1", tempAsciiZ, %Max_Path, INIFileName
      OnTop = Val(tempAsciiZ)

      Getprivateprofilestring "All", "ScaleUnits", "1", tempAsciiZ, %Max_Path, INIFileName
      ScaleUnits = Val(tempAsciiZ)

      Getprivateprofilestring "All", "cFore", Str$(%Black), tempAsciiZ, %Max_Path, INIFileName
      cFore = Val(tempAsciiZ)

      Getprivateprofilestring "All", "cBack", Str$(%Yellow), tempAsciiZ, %Max_Path, INIFileName
      cBack = Val(tempAsciiZ)

      Getprivateprofilestring "All", "DimOnLostFocus", "1", tempAsciiZ, %Max_Path, INIFileName
      DimOnLostFocus = Val(tempAsciiZ)

      Getprivateprofilestring "All", "Transparency", "255", tempAsciiZ, %Max_Path, INIFileName
      Transparency = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FontSize", "10", tempAsciiZ, %Max_Path, INIFileName
      FontSize = Val(tempAsciiZ)

      Getprivateprofilestring "All", "FontAttr", "0", tempAsciiZ, %Max_Path, INIFileName
      FontAttr = Val(tempAsciiZ)

      Getprivateprofilestring "All", "LastFontSize", "10", tempAsciiZ, %Max_Path, INIFileName
      LastFontSize = Val(tempAsciiZ)

      Getprivateprofilestring "All", "LastFontAttr", "1", tempAsciiZ, %Max_Path, INIFileName
      LastFontAttr = Val(tempAsciiZ)

      Getprivateprofilestring "All", "UseOffset", "1", tempAsciiZ, %Max_Path, INIFileName
      UseOffset = Val(tempAsciiZ)

      Getprivateprofilestring "All", "SingleSide", "0", tempAsciiZ, %Max_Path, INIFileName
      SingleSide = Val(tempAsciiZ)

      Getprivateprofilestring "All", "GripperSize", "17", tempAsciiZ, %Max_Path, INIFileName
      GripperSize = Val(tempAsciiZ)

      Getprivateprofilestring "All", "DisplayType", "0", tempAsciiZ, %Max_Path, INIFileName
      DisplayType = Val(tempAsciiZ)

      Getprivateprofilestring "All", "AdjustPPI", "0", tempAsciiZ, %Max_Path, INIFileName
      AdjustPPI = Val(tempAsciiZ)

      Getprivateprofilestring "All", "CustomPPIX", "93", tempAsciiZ, %Max_Path, INIFileName
      CustomPPIX = Val(tempAsciiZ)

      Getprivateprofilestring "All", "CustomPPIY", "93", tempAsciiZ, %Max_Path, INIFileName
      CustomPPIY = Val(tempAsciiZ)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColorC" + Format$(i,"00"), "", tempAsciiZ, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempAsciiZ)
      Next i

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      tempAsciiZ = " " + FontName
      WritePrivateProfileString "All", "FontName", tempAsciiZ, INIFileName

      tempAsciiZ = " " + LastFontName
      WritePrivateProfileString "All", "LastFontName", tempAsciiZ, INIFileName

      'save numeric variables
      tempASCIIZ = Str$(LayoutHorizontal)
      WritePrivateProfileString "All", "LayoutHorizontal", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(LeftToRight)
      WritePrivateProfileString "All", "LeftToRight", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(SysTrayMin)
      WritePrivateProfileString "All", "SysTrayMin", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(StartupMin)
      WritePrivateProfileString "All", "StartupMin", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(OnTop)
      WritePrivateProfileString "All", "OnTop", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(ScaleUnits)
      WritePrivateProfileString "All", "ScaleUnits", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(cFore)
      WritePrivateProfileString "All", "cFore", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(cBG)
      WritePrivateProfileString "All", "cBack", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(DimOnLostFocus)
      WritePrivateProfileString "All", "DimOnLostFocus", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(Transparency)
      WritePrivateProfileString "All", "Transparency", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(FontSize)
      WritePrivateProfileString "All", "FontSize", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(FontAttr)
      WritePrivateProfileString "All", "FontAttr", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(LastFontSize)
      WritePrivateProfileString "All", "LastFontSize", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(LastFontAttr)
      WritePrivateProfileString "All", "LastFontAttr", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(UseOffset)
      WritePrivateProfileString "All", "UseOffset", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(SingleSide)
      WritePrivateProfileString "All", "SingleSide", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(GripperSize)
      WritePrivateProfileString "All", "GripperSize", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(DisplayType)
      WritePrivateProfileString "All", "DisplayType", tempASCIIZ, INIFileName

      tempASCIIZ = Str$(AdjustPPI)
      WritePrivateProfileString "All", "AdjustPPI", tempASCIIZ, INIFileName

      For i = 0 To 15
         tempAsciiZ = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColorC" + Format$(i,"00"), tempAsciiZ, INIFileName
      Next i

   End If
End Sub

Sub CreateContextMenu
     Menu New PopUp To hTrayMenu
     Menu Add String, hTrayMenu, "Restore", %IDM_SysTrayRestore, %MF_Enabled
     Menu Add String, hTrayMenu, "Exit", %IDM_SysTrayQuit, %MF_Enabled

     Menu New PopUp To hColors
     Menu Add String, hColors, "Select &FG Color",  %IDM_FG,  %MF_Enabled
     Menu Add String, hColors, "Select &BG Color",  %IDM_BG,  %MF_Enabled
     Menu Add String, hColors, "Use Default &Colors",  %IDM_Default,  %MF_Enabled
     Menu Add String, hColors, "-", %IDM_Sep, 0
     Menu Add String, hColors, "&Select Font",  %IDM_SetFont,  %MF_Enabled
     Menu Add String, hColors, "Use &Last Font",  %IDM_LastFont,  %MF_Enabled
     Menu Add String, hColors, "Use &Default Font",  %IDM_DefaultFont,  %MF_Enabled

     Menu New PopUp To hAdjustPPI
     Menu Add String, hAdjustPPI, "&Adjust PPI",  %IDM_AdjustPPI,  %MF_Enabled
     Menu Add String, hAdjustPPI, "-", %IDM_Sep, 0
     Menu Add String, hAdjustPPI, "Set PPI &X",  %IDM_AdjustPPIX,  %MF_Enabled
     Menu Add String, hAdjustPPI, "Set PPI &Y",  %IDM_AdjustPPIY,  %MF_Enabled

     Menu New PopUp To hDisplay
     Menu Add String, hDisplay, "&None",  %IDM_DisplayNone,  %MF_Enabled
     Menu Add String, hDisplay, "&Ruler Size",  %IDM_DisplaySize,  %MF_Enabled
     Menu Add String, hDisplay, "&Cursor Location",  %IDM_DisplayCursor,  %MF_Enabled

     Menu New PopUp To hScales
     Menu Add String, hScales, "Pi&xels",  %IDM_Pixels,  %MF_Enabled
     Menu Add String, hScales, "&Centimeters",  %IDM_Centimeters,  %MF_Enabled
     Menu Add String, hScales, "&Inches (1/10)",  %IDM_Inches10,  %MF_Enabled
     Menu Add String, hScales, "I&nches (1/16)",  %IDM_Inches16,  %MF_Enabled
     Menu Add String, hScales, "Inc&hes (1/12/3)",  %IDM_Inches123,  %MF_Enabled
     Menu Add String, hScales, "Inche&s (1/12/4)",  %IDM_Inches124,  %MF_Enabled
     Menu Add String, hScales, "&Twips",  %IDM_Twips,  %MF_Enabled
     Menu Add String, hScales, "&Pica",  %IDM_Pica,  %MF_Enabled
     Menu Add String, hScales, "&Dialog Units",  %IDM_DialogUnit,  %MF_Enabled

     Menu New PopUp To hContext
     Menu Add String, hContext, "&Horizontal",  %IDM_Horizontal,  %MF_Enabled
     Menu Add String, hContext, "&Vertical",  %IDM_Vertical,  %MF_Enabled
     Menu Add String, hContext, "-", %IDM_Sep, 0
     Menu Add String, hContext, "&Minimize",  %IDM_Minimize,  %MF_Enabled
     Menu Add String, hContext, "-", %IDM_Sep, 0
     Menu Add String, hContext, "On &Top",  %IDM_OnTop,  %MF_Enabled
     Menu Add String, hContext, "&Dim on Lost Focus",  %IDM_Dim,  %MF_Enabled
     Menu Add String, hContext, "Display &Zero Offset",  %IDM_UseOffset,  %MF_Enabled
     Menu Add String, hContext, "&Single Side ",  %IDM_SingleSide,  %MF_Enabled
     Menu Add String, hContext, "&Left-to-Right",  %IDM_LeftToRight,  %MF_Enabled
     Menu Add String, hContext, "Minimize On Start&up",  %IDM_StartupMin,  %MF_Enabled
     Menu Add String, hContext, "System &Tray on Minimize",  %IDM_SysTrayMin,  %MF_Enabled
     Menu Add PopUp,  hContext, "Scale Options", hScales, %MF_Enabled
     Menu Add PopUp,  hContext, "Colors && Fonts", hColors, %MF_Enabled
     Menu Add PopUp,  hContext, "Display", hDisplay, %MF_Enabled
     Menu Add PopUp,  hContext, "PPI Adjustment", hAdjustPPI, %MF_Enabled
     Menu Add String, hContext, "-", %IDM_Sep, 0
     Menu Add String, hContext, "&About",  %IDM_About,  %MF_Enabled
     Menu Add String, hContext, "-", %IDM_Sep, 0
     Menu Add String, hContext, "E&xit",  %IDM_Exit,  %MF_Enabled
End Sub

Sub CreatehBMP
   Local w,h As Long
   If hBMP Then Graphic Bitmap End
   Desktop Get Size To w,h
   Graphic Bitmap New w,h To hBMP
   Graphic Attach hBMP, 0, ReDraw
   Graphic Color cFore, cBack
   Graphic Get DC To hBMPDC
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(24)
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Left  : ac(c).cmd   = %IDM_Left       : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Right : ac(c).cmd   = %IDM_Right      : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Up    : ac(c).cmd   = %IDM_Up         : Incr c
   ac(c).fvirt = %FVIRTKEY : ac(c).key   = %VK_Down  : ac(c).cmd   = %IDM_Down       : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FShift : ac(c).key   = %VK_Left  : ac(c).cmd   = %IDM_sLeft  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FShift : ac(c).key   = %VK_Right : ac(c).cmd   = %IDM_sRight : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FShift : ac(c).key   = %VK_Up    : ac(c).cmd   = %IDM_sUp    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FShift : ac(c).key   = %VK_Down  : ac(c).cmd   = %IDM_sDown   : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_H  : ac(c).cmd   = %IDM_Horizontal  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_V  : ac(c).cmd   = %IDM_Vertical    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_M  : ac(c).cmd   = %IDM_Minimize    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_O  : ac(c).cmd   = %IDM_OnTop       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_D  : ac(c).cmd   = %IDM_Dim         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_Z  : ac(c).cmd   = %IDM_UseOffset   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_S  : ac(c).cmd   = %IDM_SingleSide  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_LeftToRight : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_U  : ac(c).cmd   = %IDM_StartUpMin  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_SysTrayMin  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_X  : ac(c).cmd   = %IDM_Exit        : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_F  : ac(c).cmd   = %IDM_FG          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_B  : ac(c).cmd   = %IDM_BG          : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_P  : ac(c).cmd   = %IDM_Pixels      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_C  : ac(c).cmd   = %IDM_Centimeters : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FALT: ac(c).key   = %VK_I  : ac(c).cmd   = %IDM_Inches16    : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub MoveDialog(D$)
   Local x,y As Long
   Dialog Get Loc hDlg To x,y
   Select Case D$
      Case "L" : Dialog Set Loc hDlg, x-1,y
      Case "R" : Dialog Set Loc hDlg, x+1,y
      Case "U" : Dialog Set Loc hDlg, x,y-1
      Case "D" : Dialog Set Loc hDlg, x,y+1
   End Select
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
   SetFocus hDlg
End Function

Sub ResizeDialog(dx As Long, dy As Long)
   Local w,h As Long
   Dialog Get Size hDlg To w,h
   If (w+dx > 10) And (h+dy > 10) Then Dialog Set Size hDlg, w+dx,h+dy
End Sub

Sub SelectFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName     : FontSize = fPoints     : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
      LastFontName = fName : LastFontSize = fPoints : LastFontAttr = fStyle
   End If
End Sub

Sub DisplayInfo
 If DisplayType <> %Display_RulerSize Then Exit Sub

 Local  OffSet       As Long
 Local  Unit         As Long
 Local  UnitDivCount As Long
 Local  UnitDiv      As Long
 Local  Looper       As Long

 If LastFractionnalSpace < 0 Then LastFractionnalSpace = 0
 Select Case ScaleUnits
   Case %Pixel, %DialogUnit
     sRulerLength = LTrim$(Str$(RulerLength)) '& IIF$(RulerLength <= 1, " pixel", " pixels")

   Case %Centimener
     Unit         = RulerLength \ 10
     UnitDivCount = RulerLength Mod 10
     sRulerLength = LTrim$(Str$(Unit)) & "." & Format$(UnitDivCount, "0") & _
                    LTrim$(Str$(LastFractionnalSpace)) '& " cm"

   Case %Inch16
     Unit         = RulerLength \ 16
     UnitDivCount = RulerLength Mod 16
     UnitDiv      = 16
     If UnitDivCount > 0 Then
       Do While UnitDivCount Mod 2 = 0
         UnitDiv = UnitDiv \ 2
         UnitDivCount = UnitDivCount \ 2
       Loop
       sRulerLength = Str$(UnitDivCount) & "/" & LTrim$(Str$(UnitDiv))
     Else
       sRulerLength = ""
     End If
     sRulerLength = LTrim$(Str$(Unit)) & $Dq & sRulerLength '& IIF$(Unit <= 1, " inch", " inches")

   Case %Inch10
     Unit         = RulerLength \ 10
     UnitDivCount = RulerLength Mod 10
     sRulerLength = LTrim$(Str$(Unit)) & "." & LTrim$(Str$(UnitDivCount)) & _
                    LTrim$(Str$(LastFractionnalSpace)) & $Dq '& IIF$(Unit <= 1, " inch", " inches")

   Case %Pica, %Inch123, %Inch124 'Pica, inch 1/12/3" emphasis on 1/3 and 2/3, inch 1/12/4" emphasis on 1/4 and 3/4
     Unit         = RulerLength \ 12
     UnitDivCount = RulerLength Mod 12
     If UnitDivCount > 0 Then
       Select Case UnitDivCount
         Case 1, 5, 7, 11 : UnitDiv      = 12 '/12
         Case 2           : UnitDivCount = 1 : UnitDiv = 6 '/6
         Case 10          : UnitDivCount = 5 : UnitDiv = 6 '/6
         Case 3           : UnitDivCount = 1 : UnitDiv = 4 '/4
         Case 9           : UnitDivCount = 3 : UnitDiv = 4 '/4
         Case 4           : UnitDivCount = 1 : UnitDiv = 3 '/3  8/12 4/6 2 / 3
         Case 8           : UnitDivCount = 2 : UnitDiv = 3 '/3  8/12 4/6 2 / 3
         Case 6           : UnitDivCount = 1 : UnitDiv = 2 '/2
       End Select
       sRulerLength = Str$(UnitDivCount) & "/" & LTrim$(Str$(UnitDiv))
     Else
       sRulerLength = ""
     End If
     If ScaleUnits = %Pica Then 'pica
       sRulerLength = LTrim$(Str$(Unit)) & sRulerLength '& IIF$(Unit <= 1, " pica", " picas")
     Else '%Inch123, %Inch124
       sRulerLength = LTrim$(Str$(Unit)) & $Dq & sRulerLength '& IIF$(Unit <= 1, " inch", " inches")
     End If

   Case %Twip 'Twip 1440 per inch 0.1" = 144 twips
     Unit         = RulerLength * 100 + (LastFractionnalSpace * 10)
     sRulerLength = LTrim$(Str$(Unit)) '& IIF$(Unit <= 1, " twip", " twips")

 End Select

 'SetBkMode(hDC, cBack) : SetTextColor(hDC, cFore)
 If LayoutHorizontal Then
   If LeftToRight And UseOffSet Then OffSet = 5 Else Offset = 8
   TextOut(hDC, 10, 10, ByVal StrPtr(sRulerLength), Len(sRulerLength))
 Else
   If LeftToRight And UseOffset Then OffSet = 7 Else Offset = 9
   TextOut(hDC, 10, 10, ByVal StrPtr(sRulerLength), Len(sRulerLength))
 End If

End Sub

Sub DrawRulerSelect(ByVal inchDivider As Single, ByVal DivByUnit As Long, ByVal Arg As Long, inchDividerY As Single)
 '%Pixel      : DrawRulerSelect(1,    01,          0,     0) 'Pixel
 '%Pica       : DrawRulerSelect(6,    12,          6,     0) '1 pica is 1/6" divided in 12 parts
 '%Twip       : DrawRulerSelect(1.44, 10, 64 + 4 + 2,     0) 'Twip 1440 per inch, twentieth of a point
 '%Inch10     : DrawRulerSelect(1,    10,          0,     0) 'Inch 1/10"
 '%Inch123    : DrawRulerSelect(1,    12,          0,     0) 'Inch 1/12" emphasis on 1/3 and 2/3
 '%Inch124    : DrawRulerSelect(1,    12,          1,     0) 'Inch 1/12" emphasis on 1/4 and 3/4
 '%Inch16     : DrawRulerSelect(1,    16,          0,     0) 'Inch 1/16"
 '%DialogUnit : DrawRulerSelect(1.5,  01,        128, 1.625) 'DialogUnit, example with 1.5 x 1.625
 '%Centimener : DrawRulerSelect(2.54, 10,          0,     0) 'Centimeter

 'Arg AND 01 for 1/12" emphasis on 1/3 and 2/3 Else 1/12" emphasis on 1/4 and 3/4
 'Arg AND 02 to reduce number of lines drawn by unit
 'Arg AND 06 (2 + 4) to reduce even more the number of lines drawn by unit
 'Arg AND 64 for twips, set NumMultiplicator to 1000
 'Arg AND 128 for dialog units, set Divisor with PixelPerDialogUnitsX, inchDividerY with PixelPerDialogUnitsY

 Local DialogWidth, DialogHeight, PixelPerUnitX, PixelPerUnitY, StringUnitOffset, Num As Long
 Local Looper, x, y, LinePos, LineLen, DivisionIndex, ShowDivUnit, TopToBotom, NumMultiplicator As Long
 Local PixelPerDiv, PixelPerDialogUnitX, PixelPerDialogUnitY As Single
 Local sNum, sMeasureUnit As String

 Select Case ScaleUnits
   Case %Pixel      : sMeasureUnit = "pix"
   Case %Pica       : sMeasureUnit = "pica"
   Case %Twip       : sMeasureUnit = "twip"
   Case %DialogUnit : sMeasureUnit = "du"
   Case %Centimener : sMeasureUnit = "cm"
   Case Else        : sMeasureUnit = "inch" '%Inch10, %Inch123, %Inch124, %Inch16
 End Select

 RulerLength = 0

 TopToBotom = LeftToRight 'Just for easy reading
 If (Arg And 64) Then NumMultiplicator = 1000 Else NumMultiplicator = 1 'For twips
 Dialog Get Client hDlg To DialogWidth, DialogHeight
 Graphic Clear cBack
 Graphic Get PPI To PixelPerUnitX, PixelPerUnitY
 'PixelPerUnitX = 93 : PixelPerUnitY = 93 'Instead of 96 on my monitor for near real inch
 If AdjustPPI Then
   PixelPerUnitX = CustomPPIX
   PixelPerUnitY = CustomPPIY
 End If

 If DivByUnit = 1 Then 'Pixel or DialogUnit
   ShowDivUnit = 50
   If LayoutHorizontal Then
     PixelPerUnitX = 1
   Else
     PixelPerUnitY = 1
   End If
 Else 'Anything but pixel or DialogUnit
   ShowDivUnit = DivByUnit
 End If

 PixelPerUnitX = PixelPerUnitX / inchDivider
 PixelPerUnitY = PixelPerUnitY / inchDivider

 If LayoutHorizontal Then 'Horizontal ruler
   If (Arg And 128) Then 'DialogUnit
     PixelPerDiv = PixelPerUnitX / DivByUnit * inchDivider
   Else
     PixelPerDiv = PixelPerUnitX / DivByUnit
   End If
 Else 'Vertical ruler
   If (Arg And 128) Then 'DialogUnit
     PixelPerDiv = PixelPerUnitY / DivByUnit * inchDividerY
   Else
     PixelPerDiv = PixelPerUnitY / DivByUnit
   End If
 End If

 If UseOffset Then StartOffset = 10 Else StartOffset = 0 'Free space at the beginning
 DivisionIndex =  0

 If LayoutHorizontal Then 'Horizontal ruler
   Do
     If LeftToRight Then
       LinePos = StartOffset + (PixelPerDiv * DivisionIndex) - 1
       If LinePos > DialogWidth Then
         LastFractionnalSpace = ((PixelPerDiv - (LinePos - DialogWidth)) * 10) / PixelPerDiv
         Exit Do
       End If
     Else 'Right to left
       LinePos = (DialogWidth - StartOffset) - (PixelPerDiv * DivisionIndex)
       If LinePos < 0 Then
         LastFractionnalSpace = ((PixelPerDiv + LinePos) * 10) / PixelPerDiv
         Exit Do
       End If
     End If

     If DivisionIndex Mod ShowDivUnit = 0 Then 'Draw number and Measurement unit like "inch", "pixel", etc
       Num = (DivisionIndex \ DivByUnit) * NumMultiplicator
       sNum = LTrim$(Str$(Num))
       If DivisionIndex = 0 Then sNum = sMeasureUnit 'Like "inch"
       Graphic Text Size sNum To x, y
       LineLen = DialogHeight / 2 - y / 2
       If DivisionIndex = 0 Then
         If UseOffset Then
           If LeftToRight Then StringUnitOffset = (x / 2) + 2 Else StringUnitOffset = - ((x / 2) + 2)
         Else
           If LeftToRight Then StringUnitOffset = (x / 2) + 2 Else StringUnitOffset = - ((x / 2) + 2)
         End If
       Else
         StringUnitOffset = 0
       End If
       Graphic Set Pos ((LinePos - x / 2) + StringUnitOffset, LineLen)
       If ((inchDivider = 6) And (Num / 2 <> Num \ 2)) Then 'Pica odd number
         'Do not print odd Pica number
       Else
         Graphic Print sNum
       End If
     End If
     GoSub GetLineLen
     Graphic Line (LinePos, 0) - (LinePos, LineLen), cFore 'Top lines
     If SingleSide = 0 Then Graphic Line (LinePos, DialogHeight - LineLen) - (LinePos, DialogHeight), cFore 'Bottom's lines
     Incr DivisionIndex

   Loop
 Else 'Vertical ruler
   Do
     If TopToBotom Then
       LinePos = StartOffset + (PixelPerDiv * DivisionIndex) - 1
       If LinePos > DialogHeight Then
         LastFractionnalSpace = ((PixelPerDiv - (LinePos - DialogHeight)) * 10) / PixelPerDiv
         Exit Do
       End If
     Else 'Down to up
       LinePos = (DialogHeight - StartOffset) - (PixelPerDiv * DivisionIndex)
       If LinePos < 0 Then
         LastFractionnalSpace = ((PixelPerDiv + LinePos) * 10) / PixelPerDiv
         Exit Do
       End If
     End If

     If DivisionIndex Mod ShowDivUnit = 0 Then 'Draw number and Measurement unit like "inch", "pixel", etc
       Num = (DivisionIndex \ DivByUnit) * NumMultiplicator
       sNum = LTrim$(Str$(Num))
       If DivisionIndex = 0 Then sNum = sMeasureUnit  'Like "inch"
       Graphic Text Size sNum To x, y
       LineLen = DialogWidth / 2 - x / 2
       If DivisionIndex = 0 Then
         If UseOffset Then
           If TopToBotom Then StringUnitOffset = 2 Else StringUnitOffset = - 2
         Else
           If TopToBotom Then StringUnitOffset = y \ 2 Else StringUnitOffset = - (y \ 2)
         End If
       Else
         StringUnitOffset = 0
       End If
       Graphic Set Pos (LineLen, (LinePos - y / 2) + StringUnitOffset)
       If ((inchDivider = 6) And (Num / 2 <> Num \ 2)) Then  'Pica odd number
         'Do not print Pica odd number
       Else
         Graphic Print sNum
       End If
     End If
     GoSub GetLineLen
     Graphic Line (0, LinePos) - (LineLen, LinePos), cFore 'Lines on left
     If SingleSide = 0 Then Graphic Line (DialogWidth, LinePos) - (DialogWidth - LineLen, LinePos), cFore 'Lines on right
     Incr DivisionIndex

   Loop
 End If

 'Draw grip
 For Looper = DialogWidth - 17 To DialogWidth - 2 Step 3
   Graphic Line (Looper, DialogHeight) - (DialogWidth, DialogHeight - DialogWidth + Looper), %rgb_LightGray
   Graphic Line (Looper + 1, DialogHeight) - (DialogWidth, DialogHeight - DialogWidth + Looper + 1), %rgb_DimGray
   Graphic Line (Looper + 2, DialogHeight) - (DialogWidth, DialogHeight - DialogWidth + Looper + 2), %rgb_Gray
 Next

 Graphic ReDraw

 Decr RulerLength 'Do not remove

 Exit Sub
 GetLineLen: '-----------------------------------------------------------------
 Select Case DivByUnit

   Case 1 'Pixel and DialogUnit
     Select Case DivisionIndex Mod 100 'Pixel
       Case  0           : 'Already calculated above
       Case 50           : LineLen = 15
       Case Else         : If DivisionIndex Mod 10 = 0 Then LineLen = 10 Else _
                           If DivisionIndex Mod 2 = 0 Then LineLen = 5 Else LineLen = 0
     End Select

   Case 10 'Inch 1/10" and centimeter
     Select Case DivisionIndex Mod DivByUnit
       Case 0            : 'Already calculated above
       Case 5            : LineLen = 20 '1/2
       Case Else         : LineLen =  5 '1/10
     End Select

   Case 16 'Inch 1/16"
     Select Case DivisionIndex Mod DivByUnit
       Case 0            : 'Already calculated above
       Case 8            : LineLen = 20 '1/2
       Case 4, 12        : LineLen = 15 '1/4, 3/4
       Case 2, 6, 10, 14 : LineLen = 10 '1/8, 3/8, 5/8, 7/8
       Case Else         : LineLen =  5 '1/16, 3/16, 5/16, 7/16, 9/16, 11/16, 13/16, 15/16
     End Select

   Case 12 'Pica, inch 1/12/3, inch 1/12/4
     If ScaleUnits = %Pica Then 'Pica
         Select Case DivisionIndex Mod DivByUnit
           Case 0            : 'Already calculated above
           Case 6            : LineLen = 5 '1/2
          Case Else          : LineLen = 0 'No draw
         End Select
     Else
       If (Arg And 1) Then 'Inch 1/12" emphasis on 1/3 and 2/3
         Select Case DivisionIndex Mod DivByUnit
           Case 0            : 'Already calculated above
           Case 6            : LineLen = 20 '1/2
           Case 3, 9         : If (Arg And 4) Then LineLen = 0 Else LineLen = 15 '1/4, 3/4
          Case Else          : If (Arg And 2) Then LineLen = 0 Else LineLen =  5 '1/12, 1/6, 1/3, 5/12, 7/12, 2/3, 5/6, 11/12
         End Select
       Else '(Arg AND 1) = 0 : Inch 1/12" emphasis on 1/4 and 3/4
         Select Case DivisionIndex Mod DivByUnit
           Case 0            : 'Already calculated above
           Case 6            : LineLen = 20 '1/2
           Case 2, 4, 8, 10  : If (Arg And 4) Then LineLen = 0 Else LineLen = 15 '1/6, 1/3, 2/3, 5/6
           Case Else         : If (Arg And 2) Then LineLen = 0 Else LineLen =  5 '1/12, 1/4, 5/12, 7/12, 3/4, 11/12
         End Select
       End If
     End If

 End Select
 Incr RulerLength
 Return

'______________________________________________________________________________

'Dialog Unit: http://support.microsoft.com/kb/145994
'Some results:
' 1.500 x 1.625 for DIALOG FONT "MS Sans Serif", 8
' 1.500 x 1.625 for DIALOG FONT "Tahoma", 8
' 1.500 x 1.625 for DIALOG FONT "MS Sans Serif", 9
' 1.750 x 1.750 for DIALOG FONT "Tahoma", 9
' 2.000 x 2.000 for DIALOG FONT "MS Sans Serif", 10
' 1.750 x 2.000 for DIALOG FONT "Tahoma", 10
' 2.250 x 2.500 for DIALOG FONT "MS Sans Serif", 12
End Sub

Sub DrawRuler
 Graphic Attach hBMP, 0
 Graphic Set Font hFont
 'Arg AND  01 for 1/12" enphasis on 1/3 and 2/3 Else 1/12" enphasis on 1/4 and 3/4
 'Arg AND  02 to reduce number of lines drawn by unit
 'Arg AND  06 (2 + 4) to reduce even more the number of lines drawn by unit
 'Arg AND  64 for twips, set NumMultiplicator to 1000
 'Arg AND 128 for dialog units, set Divisor with PixelPerDialogUnitsX, inchDividerY with PixelPerDialogUnitsY
 Select Case ScaleUnits '(Divisor As Single, DivByUnit As Long, Arg As Long, inchDividerY AS Single)
   Case %Pixel      : DrawRulerSelect(1,    01,          0,     0) 'Pixel
   Case %Pica       : DrawRulerSelect(6,    12,          6,     0) '1 pica is 1/6" divided in 12 parts
   Case %Twip       : DrawRulerSelect(1.44, 10, 64 + 4 + 2,     0) 'Twip 1440 per inch, twentieth of a point
   Case %Inch10     : DrawRulerSelect(1,    10,          0,     0) 'Inch 1/10"
   Case %Inch123    : DrawRulerSelect(1,    12,          0,     0) 'Inch 1/12" emphasis on 1/3 and 2/3
   Case %Inch124    : DrawRulerSelect(1,    12,          1,     0) 'Inch 1/12" emphasis on 1/4 and 3/4
   Case %Inch16     : DrawRulerSelect(1,    16,          0,     0) 'Inch 1/16"
   Case %DialogUnit : DrawRulerSelect(1.5,  01,        128, 1.625) 'DialogUnit, example with 1.5 x 1.625
   Case %Centimener : DrawRulerSelect(2.54, 10,          0,     0) 'Centimeter
 End Select
End Sub

Function GetPPI(Value As Long) As Long
   Local temp$
   temp$ = InputBox$("Enter new value: ", "PPI Adjustment", Str$(Value), 200,250)
   If Val(temp$) < 1 Or Val(temp$) > 200 Then
       Function = Value
   Else
       Function = Val(temp$)
   End If
End Function

Sub DisplayAbout
   Local temp$, tmp$
   temp$ = "gbRuler Version: " + $ver + $CrLf
   Select Case ScaleUnits
       Case 1   : tmp$ = "Pixels"
       Case 10  : tmp$ = "Inches (1/10)"
       Case 16  : tmp$ = "Inches (1/16)"
       Case 100 : tmp$ = "Centimeters"
       Case 123 : tmp$ = "Inches (1/3)"
       Case 124 : tmp$ = "Inches (1/4)"
       Case 144 : tmp$ = "Twips"
       Case 6   : temp$ = "Pica"
   End Select
   temp$ = temp$ + $CrLf + "Scale:                       : " + tmp$
   temp$ = temp$ + $CrLf + "Font:                        : " + FontName + "," + Str$(FontSize) + Choose$(FontAttr+1,", Normal",", Bold",", Italic",", Bold-Italic")
   Select Case DisplayType
       Case %Display_None : tmp$ = "None"
       Case %Display_RulerSize : tmp$ = "Ruler Size"
       Case %Display_CursorLoc : tmp$ = "Ruler Location"
   End Select
   temp$ = temp$ + $CrLf + "Display Type            : " + tmp$
   temp$ = temp$ + $CrLf + "On Top                     : " +  IIf$(OnTop, "On","Off")
   temp$ = temp$ + $CrLf + "Dim On Lost Focus   : " +  IIf$(DimOnLostFocus, "On","Off")
   temp$ = temp$ + $CrLf + "Display Zero Offset : " +  IIf$(UseOffset, "On","Off")
   temp$ = temp$ + $CrLf + "Single Side               : " +  IIf$(SingleSide, "On","Off")
   temp$ = temp$ + $CrLf + "Left-To-Right           : " + IIf$(LeftToRight, "On","Off")
   temp$ = temp$ + $CrLf + "PPI Adjustmentt      : " + IIf$(LeftToRight, "On","Off")
   temp$ = temp$ + $CrLf + "Custom PPIX/Y Values: " + Str$(CustomPPIX) + Str$(CustomPPIY)
   MsgBox temp$, %MB_Ok + %MB_IconInformation, "gbRuler About"
End Sub

Sub MinimizeDialog
    If SysTrayMin Then
       ShowWindow hDlg, %SW_Hide 'hide prog so it doesn't appear in the task bar.
       tn.cbsize = SizeOf(tn)
       tn.hwnd   = hDlg
       tn.uid    =  GetModuleHandle(ByVal %NULL)   'g_hinst
       tn.uflags = %nif_icon Or %nif_message Or %nif_tip
       tn.ucallbackmessage = %WM_SysTray
       tn.hicon = LoadIcon(GetModuleHandle(""),"ruler")   'loadicon(%null,ByVal Mak(Long, %idi_application,0))
       tn.sztip = "gbRuler"
       Shell_NotifyIcon %nim_add, tn
'       Dialog Show State hDlg, %SW_Minimize
    Else
        Dialog Show State hDlg, %SW_Minimize
    End If
End Sub
